#include <helix-sp.h>

#include <string>
#include <iostream>
#include <fstream>

using namespace std;

int main()
{
    string in, coredir, pluginsdir, codecsdir, tmp;
    HelixSimplePlayer player;
    int numPlayers = 0;
    struct timeval tv;
    int retval;
    fd_set rfds;

    //ofstream log( "/tmp/helix-helper.log" ); Security: use mkstemp!!!

    while ( true ) {
	FD_ZERO(&rfds);
	FD_SET(0, &rfds);

	tv.tv_sec = 0;
	tv.tv_usec = 100*1000;

	retval = select (1, &rfds, NULL, NULL, &tv);

        if (retval >= 0 && numPlayers)
	    player.dispatch();

	if(retval == 1) {
	    if(cin.eof()) exit(0);
	    getline(cin, in);

            //log << in << endl << flush;
	}
	else
	    continue;

	if ( in == "***INIT" ) {
	    getline(cin, coredir);
	    getline(cin, pluginsdir);
	    getline(cin, codecsdir);
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
            numPlayers = 0;

	    player.init(coredir.c_str(), pluginsdir.c_str(), codecsdir.c_str(), nr);
	}
 	else if ( in == "***DISPATCH" ) {
	    player.dispatch();
	}
        else if ( in == "***TEARDOWN" ) {
	    player.tearDown();
	}
        else if ( in == "***ERROR" ) {
	    int ret = player.getError();
            cout << "###DOERROR:" << ret << endl << flush;
	}
        else if ( in == "***URL" ) {
	    string file;
	    getline(cin, file);
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    getline(cin, tmp);
	    bool isLocal = atoi(tmp.c_str()) != 0;

	    player.setURL( file.c_str(), nr, isLocal );
	}
        else if ( in == "***START" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.start( nr );
            if (numPlayers < 10)
              ++numPlayers;
	}
        else if ( in == "***SEEK" ) {
	    getline(cin, tmp);
	    int offset = atoi(tmp.c_str());
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.seek( offset, nr );
	}
        else if ( in == "***STOP" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.stop( nr );
            if(numPlayers > 0) --numPlayers;
	}
        else if ( in == "***PAUSE" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.pause( nr );
	}
        else if ( in == "***RESUME" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.resume( nr );
	}
        else if ( in == "***WHERE" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    int ret = player.where( nr );
            cout << "###DOWHERE:" << nr << ":" << ret << endl << flush;
	}
        else if ( in == "***DURATION" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    int ret = player.duration( nr );
            cout << "###DODURATION:" << nr << ":" << ret << endl << flush;
	} 
        else if ( in == "***VOLUME" ) {
	    getline(cin, tmp);
	    int vol = atoi(tmp.c_str());
	    player.setVolume( vol );
	}
        else if ( in == "***CLEANUP" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.cleanUpStream( nr );
	} 
        else if ( in == "***DONE" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    int ret = player.done( nr );
            cout << "###DODONE:" << nr << ":" << ret << endl << flush;
	}
        else if ( in == "***SOUNDINIT" ) {
	    player.initDirectSS();
	}
        else if ( in == "***SETDEVICE" ) {
	    getline(cin, tmp);
	    player.setDevice(tmp.c_str());
	}
        else if ( in == "***SETSINK" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.setOutputSink((HelixSimplePlayer::AUDIOAPI)nr);
	}
        else if ( in == "***ENABLEEQ" ) {
	    getline(cin, tmp);
	    int nr = atoi(tmp.c_str());
	    player.enableEQ(nr != 0);
	}
        else{
	    std::cerr << "XXXX ERROR, unhandled string >>>" <<in<<"<<<<" << endl;
	}
    }

    return 0; // never reached
}
